//
//  WiiMidiDelegate.h
//  WiiToMidi
//
//  Created by Mike Verdone on 22/12/06.
//  Copyright 2006 __MyCompanyName__. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <WiiRemote/WiiRemote.h>
#import <CoreMIDI/MIDIServices.h>

#define BUTTONDOWN(buttonId, buttonData) (((buttonData & buttonId) != 0) ? 1 : 0)

#define SIGNAL_ARR_SIZE 9

#define SA_ACC_X 0
#define SA_ACC_Y 1
#define SA_ACC_Z 2
#define SA_BUT_A 3
#define SA_BUT_B 4
#define SA_BUT_1 5
#define SA_BUT_2 6
#define SA_BUT_PLUS 7
#define SA_BUT_MINUS 8

#define MIDI_TIME_NOW 0
#define SIGNAL_RANGE 256

@interface WiiMidiDelegate : NSObject 
{
    id _controller;
    int _wiiId;
	int _midiChannel;
	MIDIClientRef _midi;
	MIDIPortRef _midiOut;
	MIDIEndpointRef _midiDest;
	WiiRemote *_wii;
	Byte _oldSignals[SIGNAL_ARR_SIZE];
	BOOL _firstTime;
	BOOL _learnMode;
	unsigned int _sensitivity;
}

-(id) initWithController:(id)c wiiId:(int)w wiiRemote:(WiiRemote*)wii;
-(void) release;

-(void) setMidiChannel:(int)midiChannel;
-(void) setLearnMode:(BOOL)learnMode;
-(void) setSensitivity:(int)sensitivity;

// WiiRemoteDelegate messages:
-(void) dataChanged:(unsigned short)buttonData accX:(unsigned char)accX accY:(unsigned char)accY accZ:(unsigned char)accZ mouseX:(float)mx mouseY:(float)my;
-(void) wiiRemoteDisconnected;

@end
