#import "WiiToMidiController.h"

@implementation WiiToMidiController

-(void) awakeFromNib
{
	[midiChannel removeAllItems];
	int i;
	for (i = 1; i <= 16; i++)
	{
		[midiChannel addItemWithTitle:[NSString stringWithFormat:@"%i",i]];
	}
 
	discovery = [[WiiRemoteDiscovery alloc] init];
	[discovery setDelegate:self];
	[discovery start];
}

-(void)wiiRemoteDisconnected:(int)wiiId {
	[wiiMidiDelegate release];
	wiiMidiDelegate = nil;
    [wiimoteMessage setStringValue:[NSString stringWithFormat:@"Press 1 and 2 buttons to connect Wiimote"]];
    [discovery start];
}

- (NSApplicationTerminateReply)applicationShouldTerminate:(NSApplication *)sender{
	if (wiiMidiDelegate != nil)
	{
		[wiiMidiDelegate release];
	}
	return NSTerminateNow;
}

-(void) midiChannelChanged:(NSPopUpButton*) button {
  if (wiiMidiDelegate != nil)
  {
	[wiiMidiDelegate setMidiChannel:[midiChannel indexOfSelectedItem]];
  }
}

@end

@implementation WiiToMidiController( WiiRemoteDiscoveryDelegate )

-(void) WiiRemoteDiscovered:(WiiRemote*)wiimote
{
  NSLog(@"Wiimote connected.");
  [discovery stop];
  wiiMidiDelegate = [[WiiMidiDelegate alloc] initWithController:self wiiId:0 wiiRemote:wiimote];
  [wiiMidiDelegate setMidiChannel:[midiChannel indexOfSelectedItem]];
  [wiimoteMessage setStringValue:[NSString stringWithFormat:@"Wiimote connected"]];
}

-(void) WiiRemoteDiscoveryError:(int)code
{
	NSLog(@"Wii remote discovery error, code %i", code);
}

@end

